<?php
namespace BrandCo\Plugins\IDX;

class AlertEmail {
	public $bcoidx_logo_branding = '';

	public function process_email($send_to, $br_message, $br_alert_id) {
		global $phpmailer;

		$bcoidx_logo_branding_id = get_option('bcoidx_logo_branding_id');
		if ( $bcoidx_logo_branding_id ) {
			$this->bcoidx_logo_branding = wp_get_original_image_path($bcoidx_logo_branding_id);
		}

		add_action('phpmailer_init', array($this, 'add_attachments_to_php_mailer'));

		$alert_post_id = Util::get_alert_by_alert_id($br_alert_id);

		$alert_type = $br_message['listing']['alertType'];
		$listing_link = get_option('siteurl') . '/' . get_option('bcoidx_app_url') . '/listing/listing--' . $br_message['listing']['mlsNum'];

		$blossorId = $br_message['listing']['blossorId'];

		$blossorId_parts = explode('-', $blossorId);

		$blossorId = $br_message['listing']['blossorId'];
		$blossorId_parts = explode('-', $blossorId);
        $image_url = $br_message['listing']['photoDomain'] . '/images/';
		$image_url .= $blossorId_parts[0];
		$image_url .= '/photo/';
		$image_url .= implode('/', str_split($blossorId_parts[1]));
		$image_url .= '/0.jpg?width=800';

		if ( 'back_on_market' == $alert_type ) {
			$subject = 'Back On Market: ' . $br_message['listing']['streetAddress'] . ' ' . $br_message['listing']['city'] . ', ' . $br_message['listing']['state'] . ' ' . $br_message['listing']['postalCode'];
		}

		if ( 'new' == $alert_type ) {
			$subject = 'New Listing: ' . $br_message['listing']['streetAddress'] . ' ' . $br_message['listing']['city'] . ', ' . $br_message['listing']['state'] . ' ' . $br_message['listing']['postalCode'];
		}

		if ( 'price_change' == $alert_type ) {
			$subject = 'Price Change: ' . $br_message['listing']['streetAddress'] . ' ' . $br_message['listing']['city'] . ', ' . $br_message['listing']['state'] . ' ' . $br_message['listing']['postalCode'];
		}

		if ( 'status_change' == $alert_type ) {
			$subject = 'Status Change: ' . $br_message['listing']['streetAddress'] . ': ' . $br_message['listing']['standardStatus'];
		}

		$message = '';
		$message .= '<div><a href="' . $listing_link . '"><img src="' . $image_url . '" style="max-width: 100%; height: auto; "></a></div>';
		$message .= '<div><a href="' . $listing_link . '">' . $br_message['listing']['streetAddress'] . '</a></div>';
		$message .= '<div><a href="' . $listing_link . '">' . $br_message['listing']['city'] . ', ' . $br_message['listing']['state'] . ' ' . $br_message['listing']['postalCode']  . '</a></div>';
		$message .= '<div style="color: green; margin-bottom: 20px;">$' . number_format($br_message['listing']['price']) . '</div>';
		$message .= '<div style="text-align: center;"><a href="' . $listing_link . '" style="background: #1155cc; color: white; text-decoration: none; padding: 10px 20px; border-radius: 5px; font-size: 18px;">Check it out!</a></div>';

		$from_name = ( !get_option('bcoidx_email_from_name') ) ? get_option('bcoidx_email_from_name') : get_option('blogname');

		$headers = array(
			'From: ' . $from_name . ' <' . get_option('bcoidx_main_email') . '>',
			'Reply-To: ' . get_option('blogname') . ' <' . get_option('bcoidx_main_email') . '>',
			'Content-Type: text/html; charset=UTF-8'
		);

		$template = $this->template($subject, $message, $send_to, $alert_post_id);

		$attachments = array();
		if ( $this->bcoidx_logo_branding ) {
			$attachments = array($this->bcoidx_logo_branding);
		}

		$sent = wp_mail(
			$send_to,
			$subject,
			$template,
			$headers,
		);

		remove_action('phpmailer_init', array($this, 'add_attachments_to_php_mailer'));

		return $sent;
	}

	public function template($title, $body, $send_to, $alert_post_id) {

		$bcoidx_email_footer = get_option('bcoidx_email_footer');

		ob_start();
		?>
		<center>
			<table style="max-width: 480px; font-size: 16px; color: black;">
				<tbody>
					<?php if ( $this->bcoidx_logo_branding ) : ?>
						<tr>
							<center>
								<img src="cid:ppidx_image_0" height="auto" width="auto" style="display: block; margin: 10px auto 30px; max-width: 200px; width: auto; height: auto;">
							</center>
						</tr>
					<?php endif; ?>
					<tr>
						<td><h2><center><?php echo $title; ?></center></h2></td>
					</tr>
					<tr>
						<td><?php echo $body; ?></td>
					</tr>
					<tr>
						<td style="font-size: 14px; text-align: center;">
							<br><hr><br>
							<div style="color: black;">

								<?php if ( $bcoidx_email_footer ) : ?>
									<div style="color: black;">
										<?php echo wpautop($bcoidx_email_footer); ?>
									</div>
									<br><hr><br>
								<?php endif; ?>

								<?php if ( $alert_post_id ) : ?>
									<?php if ( get_post_type($alert_post_id) == 'bcoidx_savedsearch' ) : ?>
										<div>
											<div>You recieved this message because of your saved search:</div>
											<?php echo get_the_title($alert_post_id); ?>
										</div>
									<?php endif; ?>
									<?php if ( get_post_type($alert_post_id) == 'bcoidx_favlistings' ) : ?>
										<div>
											<div>You recieved this message because you signed up for alert for:</div>
											<?php echo get_the_title($alert_post_id); ?>
										</div>
									<?php endif; ?>
								<?php endif; ?>

								<div>
									<a href="<?php echo Util::app_url('/'); ?>/">Search MLS</a> |
									<a href="<?php echo Util::app_url('/dashboard/profile'); ?>/">My Account</a> |
									<a href="<?php echo Util::app_url('/optout'); ?>/#<?php echo $send_to; ?>">Unsubscribe</a>
								</div>

							</div>
						</td>
					</tr>
				</tbody>
			</table>
		</center>
		<?php
		$template = ob_get_contents();
		ob_end_clean();
		return $template;
	}

	public function add_attachments_to_php_mailer(&$phpmailer) {
		if ( $this->bcoidx_logo_branding ) {
			$phpmailer->SMTPKeepAlive = true;
			$phpmailer->AddEmbeddedImage($this->bcoidx_logo_branding, 'ppidx_image_0');
		}
	}
}

