<?php
namespace BrandCo\Plugins\IDX;

class AutocompleteRequest {
	public $path;
	public $body = array();

	public function __construct($body = array()) {

		// if ( !defined('PROPERTYPRESS_IDX_API') ) {
		// 	define('PROPERTYPRESS_IDX_API', 'https://propertypress.com/wp-json/pp/v1');
		// }

		// $this->path = PROPERTYPRESS_IDX_API . '/autocomplete';

		$this->path = 'https://api.brandco.com/api/idx/autocomplete';

		if ( Util::isLocal() ) {
			$this->path = 'https://apidash2.dev/api/idx/autocomplete';
		}

		$this->body = $body;

		if ( empty($this->body['mlses']) ) {
			$mlses = Util::get_allowed_mls_ids();
			$this->body['mlses'] = implode(',', $mlses);
		}
	}

	public function send_request() {
		$endpoint = $this->path . '?' . http_build_query($this->body);

		// $args = array(
		// 	'method' => 'GET',
		// 	'headers' => array(
		// 		'Authorization' => 'Bearer ' . base64_encode(Util::get_origin_domain()),
		// 		'Content-Type' => 'application/json'
		// 	),
		// 	'timeout' => 15,
		// );

		// $args = array(
		// 	'method' => 'GET',
		// 	'headers' => array(
		// 		'Authorization' => 'Bearer 1234',
		// 		'Content-Type' => 'application/json'
		// 	),
		// 	'timeout' => 15,
		// );

		$request = wp_remote_request($endpoint, $args);

		if ( is_wp_error($request) || wp_remote_retrieve_response_code($request) !== 200 ) {
			error_log(print_r($request, true));
		}

		$response = wp_remote_retrieve_body($request);

		$output = array(
			'response' => json_decode($response, true),
			'endpoint' => $endpoint,
			'args' => $args
		);

		return $output;
	}

	public function send_request_v2() {
		$endpoint = $this->path . '?' . http_build_query($this->body);

		$ch = curl_init($endpoint);

		// curl_setopt($ch, CURLOPT_HTTPHEADER, array(
		// 	'Content-Type: application/json',
		// 	'Authorization: Bearer ' . base64_encode(Util::get_origin_domain()),
		// ));

		curl_setopt($ch, CURLOPT_HTTPHEADER, [
			'Content-Type: application/json',
			'Authorization: Bearer 1234',
			'X-API-Key: ' . Util::get_origin_domain(),
		]);

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

		if ( Util::isLocal() ) {
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		}

		$response = curl_exec($ch);
		curl_close($ch);

		// var_dump($response); die;

		$output = array(
			'response' => json_decode($response, true),
			'endpoint' => $endpoint,
			// 'args' => $args
		);

		return $output;
	}
}
