<?php
namespace BrandCo\Plugins\IDX;
use WP_Query;

class FavoriteListings {

	public static function register_post_type() {
		$args = array(
			'public' => true,
			'supports' => array(
				'revisions'
			),
			'label' => 'Favorite Listings',
			'has_archive' => true,
			'rewrite' => array(
				'slug' => 'bcoidx-favorite-listings'
			),
			'show_in_admin_bar' => false,
			'show_in_menu' => false,
			'show_in_nav_menus' => false,
			'show_ui' => false,
			'publicly_queryable' => false,
			'exclude_from_search' => true,
  		);

		register_post_type('bcoidx_favlistings', $args);
	}

	public static function metabox() {
		add_meta_box(
			'bcoidx_favlistings_metabox',
			'Favorite Listings Details',
			__NAMESPACE__ . '\FavoriteListings::metabox_content',
			'bcoidx_favlistings'
		);
	}

	public static function metabox_content($post) {

		$mlsnum = get_post_meta($post->ID, 'bcoidx_favorite_listing_mlsnum', true);
		$mlsid = get_post_meta($post->ID, 'bcoidx_favorite_listing_mlsid', true);

		$brivity_alert_id = get_post_meta($post->ID, 'bcoidx_favorite_listing_brivityalertid', true);
		$lead = get_user_by('id', $post->post_author);

		if ( !$mlsnum ) {
			echo 'Invalid';
		}

		?>
			<style>
				#publish,
				.wp-heading-inline,
				.page-title-action {
					display: none !important;
				}
			</style>
			<table class="form-table">
				<tr>
					<th>MLS Number</th>
					<td><?php echo $mlsnum; ?></td>
				</tr>
				<tr>
					<th>Lead</th>
					<td><?php echo $lead->display_name; ?></td>
				</tr>
				<tr>
					<th>Alert ID</th>
					<td><?php echo $brivity_alert_id; ?></td>
				</tr>
			</table>
		<?php
	}

	public static function get_my($user_id) {
		$favs = array();

		$query = new WP_Query(array(
			'post_type' => 'bcoidx_favlistings',
			'posts_per_page' => -1,
			'author' => $user_id,
			'post_status' => 'publish'
		));

		if ( $query->have_posts() ) {
			while ( $query->have_posts() ) {
				$query->the_post();
				$result = get_post();

				$mlsnum = get_post_meta($result->ID, 'bcoidx_favorite_listing_mlsnum', true);

				// $mlsid = get_post_meta($result->ID, 'bcoidx_favorite_listing_mlsid', true);

				if ( $mlsnum ) {
					$favs[] = array(
						'favorite_post_id' => $result->ID,
						'mlsnum' => $mlsnum,
						'title' => get_the_title(),
						'alertid' => get_post_meta($result->ID, 'bcoidx_favorite_listing_brivityalertid', true),
						// 'mlsid' => $mlsid,
					);
				}
			}

			$query->reset_postdata();
		}

		return $favs;
	}
}
