<?php
namespace BrandCo\Plugins\IDX;

class MLSMetadata {

	public static function get() {
		$cached_metadata = get_transient('ppidx_mls_metadata');

		if ( $cached_metadata ) {
			return $cached_metadata;
		}

		if ( ! function_exists('wp_remote_request') ) {
			return false;
		}

		$endpoint = PROPERTYPRESS_IDX_API . '/mls-metadata';
		$request = wp_remote_request($endpoint, Util::request_args('GET'));

		if ( is_wp_error($request) ) {
			wp_die($request);
		}

		$response = wp_remote_retrieve_body($request);

		if ( $request['response']['code'] == 200 ) {
			$response = json_decode($response, true);

			if ( empty($response['error']) && !empty($response[0]) ) {
				set_transient('ppidx_mls_metadata', $response, 24 * HOUR_IN_SECONDS);
				return $response;
			}
		}

		return false;
	}
}
