<?php
namespace BrandCo\Plugins\IDX;

class Preload {

	public static function fetch($template) {

		if ( defined('BRANDCO_IDX_SEARCH_PAGE') ) {
			$encoded_params = ( !empty($_GET['q']) ) ? $_GET['q'] : get_option('bcoidx_initial_search');

			$params = array();
			if ( $encoded_params ) {
				$params = Util::decode_params($encoded_params);
			}

			self::fetch_search_listings($params);
			// self::fetch_metadata();
		}

		if ( defined('BRANDCO_IDX_DETAILS_PAGE') ) {
			self::fetch_single_listing(BRANDCO_IDX_DETAILS_PAGE);
			// self::fetch_metadata();
		}

		return $template;
	}

	private static function fetch_single_listing($listing_id) {
		$response = SingleListing::get($listing_id);
		global $bcoidx_listing_details;
		$listing = '';
		if ( !empty($response['response']['response']['listings_response']['listings']) ) {
			$listing = $response['response']['response']['listings_response']['listings'][0];
		}
		$bcoidx_listing_details = $listing;
	}

	private static function fetch_search_listings($params) {

		global $bcoidx_mls_metadata;
		$mls_agent_list = Util::mls_agent_list($bcoidx_mls_metadata);
		$mls_office_list = Util::mls_office_list($bcoidx_mls_metadata);

		// $request = new SearchListings($params);
		// $response = $request->send_request_v2();

		if ( !$params ) {
			$params['queryOptions']['sort'] = array(
				array('field' => 'listDate',  'order' => 'desc')
			);
		}

		$response = Ajax::search(array(
			'omni' => false,
			'parameters' => json_encode($params),
			'mls_agent_list' => $mls_agent_list,
			'mls_office_list' => $mls_office_list,
		));

		global $bcoidx_preload_search_results;
		$bcoidx_preload_search_results = array(
			'parameters' => $params,
			'response' => $response,
		);

	}

	public static function fetch_metadata() {
		global $bcoidx_mls_metadata;
		$bcoidx_mls_metadata = MLSMetadata::get();
	}
}
