<?php
namespace BrandCo\Plugins\IDX;

class Router {

	public static function query_vars($query_vars) {
		$query_vars[] = 'idx_search_page';
		$query_vars[] = 'idx_app_page';
		$query_vars[] = 'mls_id';
		return $query_vars;
	}

	public static function generate_rewrite_rules($wp_rewrite) {
		$wp_rewrite->rules = array_merge(array(
			get_option('bcoidx_app_url') . '/?$' => 'index.php?idx_search_page=true',
			get_option('bcoidx_app_url') . '/listing/([^/]+)/?' => 'index.php?mls_id=$matches[1]',
			get_option('bcoidx_app_url') . '/([^/]+)/?' => 'index.php?idx_app_page=$matches[1]',
		), $wp_rewrite->rules);
	}

	public static function template_include($original_template) {

		if ( get_query_var('post_type') == 'bcoidx_hotsheets' ) {
			$original_template = BRANDCO_IDX_PLUGIN_PATH . 'public/views/hotsheet-page.php';
		}

		// $hotsheet = get_page_by_path(get_query_var('idx_app_page'), OBJECT, 'bcoidx_hotsheets');

		// if ( $hotsheet ) {
		// 	define('PPIDX_HOTSHEET_PAGE', true);
		// 	global $post;
		// 	global $bcoidx_hotsheet_id;
		// 	$post = $hotsheet;
		// 	setup_postdata($post);
		// 	$bcoidx_hotsheet_id = $hotsheet->ID;
		// 	$original_template = BRANDCO_IDX_PLUGIN_PATH . 'public/views/hotsheet-page.php';
		// }

		if ( get_query_var('idx_search_page') ) {

			global $bcoidx_mls_metadata;
			$bcoidx_mls_metadata = MLSMetadata::get();

			define('BRANDCO_IDX_PAGE', true);
			define('BRANDCO_IDX_SEARCH_PAGE', true);

			header('X-LiteSpeed-Cache-Control: no-cache');
			nocache_headers();

			$original_template = BRANDCO_IDX_PLUGIN_PATH . 'public/views/app.php';
		}

		if ( get_query_var('idx_app_page') ) {
			$slug = get_query_var('idx_app_page');

			if ( in_array($slug, array('login', 'dashboard', 'optout')) ) {
				define('BRANDCO_IDX_PAGE', true);
				define('BRANDCO_IDX_SUBPAGE', $slug);

				global $bcoidx_mls_metadata;
				if ( $bcoidx_mls_metadata ) {
					$bcoidx_mls_metadata = MLSMetadata::get();
				}

				return BRANDCO_IDX_PLUGIN_PATH . 'public/views/app.php';
			}
		}

		if ( get_query_var('mls_id') ) {

			global $bcoidx_mls_metadata;
			$bcoidx_mls_metadata = MLSMetadata::get();

			$slug = get_query_var('mls_id');
			$listing_id = Util::get_listing_id_from_detail_page_slug($slug);

			define('BRANDCO_IDX_PAGE', true);
			define('BRANDCO_IDX_DETAILS_PAGE', $listing_id);

			header('X-LiteSpeed-Cache-Control: no-cache');
			nocache_headers();

			$original_template = BRANDCO_IDX_PLUGIN_PATH . 'public/views/app.php';
		}

		return $original_template;
	}
}

