<?php
namespace BrandCo\Plugins\IDX;

class SEO {

	public static function set_title($title) {

		if ( defined('BRANDCO_IDX_DETAILS_PAGE') ) {
			global $bcoidx_listing_details;

			if ( empty($bcoidx_listing_details) ) {
				return;
			}

			if ( !empty($bcoidx_listing_details['hideAddress']) && $bcoidx_listing_details['hideAddress'] === true ) {
				return;
			}

			$title = '';
			$title .= ( $bcoidx_listing_details['propertyType'] == 'Residential Lease' ) ? 'FOR RENT: ' : 'FOR SALE: ';

			if ( empty($bcoidx_listing_details['bathsTotalDecimal']) ) {
				$bcoidx_listing_details['bathsTotalDecimal'] = 0;
			}

			$title .= $bcoidx_listing_details['streetAddress'] . ', ' .
				$bcoidx_listing_details['city'] . ', ' .
				$bcoidx_listing_details['state'] . ' - ' .
				$bcoidx_listing_details['bedrooms'] . ' Bed / ' .
				$bcoidx_listing_details['bathsTotalDecimal'] . ' Bath';
		}

		if ( defined('PPIDX_HOTSHEET_PAGE') ) {
			global $bcoidx_hotsheet_id;
			$title = get_the_title($bcoidx_hotsheet_id);
		}

		return $title;
	}

	public static function set_canonical($canonical) {
		if ( defined('BRANDCO_IDX_DETAILS_PAGE') ) {
			global $bcoidx_listing_details;

			if ( !empty($bcoidx_listing_details['hideAddress']) && $bcoidx_listing_details['hideAddress'] === true ) {
				return;
			}

			$canonical = Util::app_url() . 'listing/' . Util::make_listing_slug($bcoidx_listing_details);
		}

		return $canonical;
	}

	public static function set_og_tags() {
		if ( defined('BRANDCO_IDX_DETAILS_PAGE') ) {
			global $bcoidx_listing_details;

			if ( empty($bcoidx_listing_details) ) {
				return;
			}

			if ( !empty($bcoidx_listing_details['hideAddress']) && $bcoidx_listing_details['hideAddress'] === true ) {
				return;
			}

			$title = '';
			$title .= ( $bcoidx_listing_details['propertyType'] == 'Residential Lease' ) ? 'FOR RENT: ' : 'FOR SALE: ';

			if ( empty($bcoidx_listing_details['bathsTotalDecimal']) ) {
				$bcoidx_listing_details['bathsTotalDecimal'] = 0;
			}

			$title .= $bcoidx_listing_details['streetAddress'] . ', ' .
				$bcoidx_listing_details['city'] . ', ' .
				$bcoidx_listing_details['state'] . ' - ' .
				$bcoidx_listing_details['bedrooms'] . ' Bed / ' .
				$bcoidx_listing_details['bathsTotalDecimal'] . ' Bath';
			$photo = ($bcoidx_listing_details['photosAvailable'] > 0) ? $bcoidx_listing_details['photos'][0]['url'] : '';

			?>
				<meta property="og:title" content="<?php echo $title; ?>">
				<meta property="og:description" content="Check out this listing: <?php echo $title; ?>">
				<meta property="twitter:title" content="<?php echo $title; ?>">
				<?php if ( $photo ) : ?><meta property="og:image" content="<?php echo $photo; ?>&width=1000"><?php endif; ?>
				<?php if ( $photo ) : ?><meta property="twitter:image" content="<?php echo $photo; ?>&width=1000"><?php endif; ?>
				<meta name="twitter:card" content="summary_large_image"/>
			<?php
		}
	}
}
