<?php
namespace BrandCo\Plugins\IDX;

class SocialLogin {

	public static function after_register($user_id) {
		$user = new \WP_User($user_id);
		$user->remove_role('subscriber');
		$user->add_role('bcoidx_lead');

		if ( \NextendSocialLogin::getTrackerData() == 'registered_from') {
			$user = new WP_User($user_id);
			add_user_meta($user->ID, 'registered_from', $_COOKIE['registered_from']);
		}

		$person = array(
			'first' => $user->display_name,
			'last' => '',
			'email' => $user->user_email,
			'phone' => '',
			'note' => 'Registered'
		);

		$activity_id = Activity::log(
			$user->ID,
			'New User Registration | ' . $user->display_name . ' ' . $user->user_email,
			$user->display_name . ' ' . $user->user_email . ' registered.',
			'user_registered',
			$person
		);

		$to = ( get_option('bcoidx_main_email') ) ? get_option('bcoidx_main_email') : get_option('admin_email');
		$subject = 'New IDX Lead Registration';
		$message = $user->display_name . ' ' . $user->user_email . ' registered.';
		$email_2 = get_option('bcoidx_main_email_2');
		$from_name = ( get_option('bcoidx_email_from_name') ) ? get_option('bcoidx_email_from_name') : get_option('blogname');

		$headers = array(
			'From: ' . $from_name . ' <' . $to . '>',
			'Content-Type: text/html; charset=UTF-8'
		);

		if ( $email_2 ) {
			$headers[] = 'Cc: ' . $email_2;
		}

		$sent = wp_mail($to, $subject, $message, $headers);

		do_action('propertypressidx/activity/user_identified', array(
			'first_name' => $user->display_name,
			'last_name' => '',
			'email_address' => $user->user_email,
			'phone_number' => '',
			'message' => 'User Registered',
		));

		return array(
			'user' => $user,
			'activity_id' => $activity_id,
			'sent' => $sent,
		);
	}
}
