<?php
namespace BrandCo\Plugins\IDX;

class Updater {

	public static function info($res, $action, $args) {
		if ('plugin_information' !== $action) {
			return false;
		}

		$plugin_slug = 'brandco-idx';

		if ( $plugin_slug !== $args->slug ) {
			return false;
		}

		if ( false == $remote = get_transient( 'bcore_update_' . $plugin_slug ) ) {
			$remote = wp_remote_get(BRANDCO_IDX_PLUGIN_REMOTE_INFO, array(
				'timeout' => 10,
				'headers' => array(
					'Accept' => 'application/json'
				))
			);

			if ( ! is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && ! empty( $remote['body'] ) ) {
				set_transient( 'bcore_update_' . $plugin_slug, $remote, 310 );
			}
		}

		if ( ! is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && ! empty( $remote['body'] ) ) {
			$remote = json_decode( $remote['body'] );
			$res = new \stdClass();

			$res->name = $remote->name;
			$res->slug = $plugin_slug;
			$res->version = $remote->version;
			// $res->tested = $remote->tested;
			// $res->requires = $remote->requires;
			$res->author = '<a href="https://brandco.com">BRANDco.</a>';
			$res->author_profile = 'https://brandco.com';
			$res->download_link = $remote->download_url;
			$res->trunk = $remote->download_url;
			// $res->requires_php = '5.3';
			$res->last_updated = $remote->last_updated;
			$res->sections = array(
				'description' => $remote->sections->description,
				// 'installation' => $remote->sections->installation,
				'changelog' => $remote->sections->changelog,
			);

			return $res;
		}

		return false;
	}

	public static function update($transient) {
		if ( empty($transient->checked ) ) {
			return $transient;
		}

		if ( false == $remote = get_transient( 'bcore_upgrade_brandco-idx' ) ) {
			$remote = wp_remote_get(BRANDCO_IDX_PLUGIN_REMOTE_INFO, array(
				'timeout' => 25,
				'headers' => array(
					'Accept' => 'application/json'
				))
			);

			if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && !empty( $remote['body'] ) ) {
				set_transient('bcore_upgrade_brandco-idx', $remote, 310);
			}
		}

		if ( !is_wp_error($remote) ) {
			$remote = json_decode($remote['body']);
			if ( $remote && version_compare(BRANDCO_IDX_PLUGIN_VERSION, $remote->version, '<' ) ) {
				$res = new \stdClass();
				$res->slug = 'brandco-idx';
				$res->plugin = 'brandco-idx/brandco-idx.php';
				$res->new_version = $remote->version;
				// $res->tested = $remote->tested;
				$res->package = $remote->download_url;
				$transient->response[$res->plugin] = $res;
			}
		}

		return $transient;
	}

	public static function after_update($upgrader_object, $options) {
		if ( $options['action'] == 'update' && $options['type'] === 'plugin' )  {
			delete_transient('bcore_upgrade_brandco-idx');
			delete_transient('bcore_update_brandco-idx');
		}
	}
}
