<?php
namespace BrandCo\Plugins\IDX;

class WPAdmin {

	public static function css_hide_from_production() {
		?>
			<style>
				#menu-posts-bcoidx_activity,
				#menu-posts-bcoidx_hotsheets,
				#menu-posts-bcoidx_savedsearch,
				#menu-posts-bcoidx_favlistings {
					display: none;
				}

				.propertypress-idx-shortcodes-modal td {
					padding-bottom: 10px;
				}

				.propertypress-idx-shortcodes-modal form {
					background: #eee;
					padding: 20px;
				}
			</style>
		<?php
	}

	public static function shortcode_modal() {
		global $pagenow;

		if ( empty($_GET['post'])  && 'post-new.php' !== $pagenow ) {
			return;
		}

		$hotsheets = get_posts(array(
			'post_type' => 'bcoidx_hotsheets',
			'posts_per_page' => -1,
		));

		add_thickbox();
		?>

		<div id="propertypress-idx-shortcodes-modal" style="display:none;">
			<div class="propertypress-idx-shortcodes-modal">
				<h2>PropertyPress IDX Widgets</h2>
				<hr>
				<h3>Insert widget from a saved search</h3>
				<table>
					<tr>
						<th>Search Form Widget</th>
						<td><a href="#0" class="button" data-propertypressidx-insert="search">Insert Quick Search</a></td>
					</tr>
					<tr>
						<th>Grid Widget</th>
						<td>
							<select name="for_grid" style="width: 200px;">
								<option value="">(pick search criteria)</option>
								<?php foreach ( $hotsheets as $hotsheet ) : ?>
									<option value="<?php echo $hotsheet->ID; ?>"><?php echo $hotsheet->post_title; ?></option>
								<?php endforeach; ?>
							</select>
							<a href="#0" class="button" data-propertypressidx-insert="grid">Insert Grid</a>
						</td>
					</tr>
					<tr>
						<th>Slider Carousel Widget</th>
						<td>
							<select name="for_slider" style="width: 200px;">
								<option value="">(pick search criteria)</option>
								<?php foreach ( $hotsheets as $hotsheet ) : ?>
									<option value="<?php echo $hotsheet->ID; ?>"><?php echo $hotsheet->post_title; ?></option>
								<?php endforeach; ?>
							</select>
							<a href="#0" class="button" data-propertypressidx-insert="slider">Insert Slider Carousel</a>
						</td>
					</tr>
				</table>
				<hr>
				<h3>Create Widget</h3>
				<form class="propertypress-widget-creator">
					<table>
						<tr><th>Neighborhood, City, State, Zip</th> <td><input type="text" name="area"></td></tr>
						<tr><th>MLS Listing IDs</th> <td><input type="text" name="mls_ids"></td></tr>
						<tr><th>Agent ID</th> <td><input type="text" name="agent_ids"></td></tr>
						<tr><th>Office ID</th> <td><input type="text" name="office_id"></td></tr>
						<tr><th>Min. Price</th> <td><input type="number" name="min_price"></td></tr>
						<tr><th>Max. Price</th> <td><input type="number" name="max_price"></td></tr>
						<tr><th>Min. Bed</th> <td><input type="number" name="bed"></td></tr>
						<tr><th>Min. Bath</th> <td><input type="number" name="bath"></td></tr>
						<tr>
							<th>Status</th>
							<td>
								<label><input type="checkbox" name="statuses[]" value="1"> Active</label>
								<label><input type="checkbox" name="statuses[]" value="3"> Active Contingent</label>
								<label><input type="checkbox" name="statuses[]" value="2"> Pending</label>
								<label><input type="checkbox" name="statuses[]" value="4"> Sold</label>
							</td>
						</tr>
						<tr>
							<th>Property Types</th>
							<td>
								<label><input type="checkbox" name="property_types[]" value="Residential"> Residential</label>
								<label><input type="checkbox" name="property_types[]" value="Condo/Townhome"> Condo/Townhome</label>
								<label><input type="checkbox" name="property_types[]" value="Multi-Family"> Multi-Family</label>
								<label><input type="checkbox" name="property_types[]" value="Farm/Ranch"> Farm/Ranch</label>
								<label><input type="checkbox" name="property_types[]" value="Residential Lease"> Residential Lease</label>
								<label><input type="checkbox" name="property_types[]" value="Commercial Sale"> Commercial Sale</label>
								<label><input type="checkbox" name="property_types[]" value="Commercial Lease"> Commercial Lease</label>
							</td>
						</tr>

						<tr>
							<th>Widget Type</th>
							<td>
								<select name="widget_type">
									<option value="idx_grid">Grid</option>
									<option value="idx_slider">Slider Carousel</option>
								</select>
							</td>
						</tr>
						<tr>
							<th>Order</th>
							<td>
								<select name="order">
									<option value="">Newest</option>
									<option value="high_to_low">Highest Price First</option>
									<option value="low_to_high">Lowest Price First</option>
								</select>
							</td>
						</tr>
						<tr>
							<th>Agent or Office Only</th>
							<td>
								<select name="for">
									<option value=""></option>
									<option value="agent">Agent Only</option>
									<option value="office">Office Only</option>
								</select>
							</td>
						</tr>
						<tr>
							<th>Limit</th>
							<td>
								<input type="number" max="100" min="1" name="limit">
							</td>
						</tr>
						<tr>
							<td colspan="2">
								<a href="#0" class="button">Insert Widget</a>
							</td>
						</tr>
					</table>
				</form>
			</div>
		</div>

			<script>
				;(function($) {
					$(document).ready(function() {
						$('#insert-media-button').after('<a href="#TB_inline?&width=600&height=550&inlineId=propertypress-idx-shortcodes-modal" class="propertypress-idx-shortcodes-tb-js thickbox button">IDX Shortcodes</a>');
						// $(document).on('click', '.propertypress-idx-shortcodes-tb-js', function(e) {
						// 	e.preventDefault();

						// });

						$('[data-propertypressidx-insert]').click(function(e) {
							e.preventDefault();
							var shortcode = $(this).attr('data-propertypressidx-insert');

							if ( shortcode == 'search' ) {
								window.tinyMCE.execCommand('mceInsertContent', 0, '[idx_quick_search]');
							}

							if ( shortcode == 'grid' ) {
								var hotsheet = $('[name="for_grid"]').val();
								window.tinyMCE.execCommand('mceInsertContent', 0, '[idx_grid savedsearch="' + hotsheet + '"]');
							}

							if ( shortcode == 'slider' ) {
								var hotsheet = $('[name="for_slider"]').val();
								window.tinyMCE.execCommand('mceInsertContent', 0, '[idx_slider savedsearch="' + hotsheet + '"]');
							}

							window.tb_remove();
						});

						$('.propertypress-widget-creator .button').click(function(e) {
							e.preventDefault();
							var shortcode_string = '[';
							var form = $('.propertypress-widget-creator');
							var type = form.find('[name="widget_type"]').val();
							shortcode_string = shortcode_string + type + ' ';

							var fields = {};
							fields.area = form.find('[name="area"]').val();
							// fields.mlsNums = form.find('[name="mls_ids"]').val();
							// fields.agentIds = form.find('[name="agent_ids"]').val();
							// fields.officeIds = form.find('[name="office_id"]').val();
							fields.min_price = form.find('[name="min_price"]').val();
							fields.max_price = form.find('[name="max_price"]').val();
							fields.beds = form.find('[name="bed"]').val();
							fields.baths = form.find('[name="bath"]').val();
							fields.order = form.find('[name="order"]').val();
							fields.for = form.find('[name="for"]').val();
							fields.limit = form.find('[name="limit"]').val();

							fields.statuses = []
							$("input[name='statuses[]']:checked").each(function() {
								fields.statuses.push(parseInt($(this).val()));
							});
							fields.statuses = fields.statuses.join(',');

							fields.property_types = []
							$("input[name='property_types[]']:checked").each(function() {
								fields.property_types.push($(this).val());
							});
							fields.property_types = fields.property_types.join(',');

							$.each(fields, function(key, value) {
								if ( value ) {
									shortcode_string = ' ' + shortcode_string + key + '="' + value + '" ';
								}
							});

							shortcode_string = shortcode_string + ']';

							window.tinyMCE.execCommand('mceInsertContent', 0, shortcode_string);
							window.tb_remove();
						});
					});
				})(jQuery);
			</script>
		<?php
	}

	public static function profile_box($user) {
		$activity = Activity::get_my($user->ID);
		?>
			<div id="idx-activity">
				<h2>IDX Lead Activity</h2>
				<table class="wp-list-table widefat fixed striped table-view-list">
					<thead>
						<tr>
							<th>Activity</th>
						</tr>
					</thead>
					<tbody>

						<?php foreach ( $activity as $a ) : ?>

							<tr>
								<td>
									<strong>
										<?php
											if ( $a['type'] == 'saved_search' ) {
												echo 'Saved Search: ';
											}

											if ( $a['type'] == 'favorited_listing' ) {
												echo 'Favorited a listing: ';
											}

											if ( $a['type'] == 'contact_form' ) {
												echo 'Filled out a contact form: ';
											}

											if ( $a['type'] == 'listing_alert_email_sent' ) {
												echo 'Received Listing Alert Email: ';
											}
									 	?>
									</strong>
									<?php echo $a['title']; ?>
								</td>
							</tr>
						<?php endforeach; ?>
					</tbody>
				</table>
			</div>
		<?php
	}
}
