(() => {
	if ( typeof window.bcoidx_tried_to_load == 'boolean' ) {
		console.log('Exiting duplicate script');
		return;
	}

	window.bcoidx_tried_to_load = true;
	window.bcoidx = null;

	if ( typeof window.propertypress_idx_site == 'undefined' ) {
		console.warn('PropertyPress IDX requires window.propertypress_idx_site variable to be defined.');
		return;
	}

	if ( !window.propertypress_idx_site.includes('search.cevado.com') ) {
		window.propertypress_idx_site = window.propertypress_idx_site.replace('/', '');
	}

	if ( window.propertypress_idx_site.includes('/search.cevado.com') ) {
    	window.propertypress_idx_site = window.propertypress_idx_site.replace('/', '');
    }

	async function addWidget(shortcode) {
		const response = await fetch('https://' + window.propertypress_idx_site + '/wp-json/idx/v1/shortcodes/make?shortcode=' + encodeURIComponent(shortcode) + '&origin=' + window.propertypress_idx_site);
		return response.json();
	}

	propertypress_idx_load_script('//' + window.propertypress_idx_site + '/wp-content/plugins/brandco-idx/public/js/brandco-idx-shortcodes.js');
	propertypress_idx_load_stylesheet('//' + window.propertypress_idx_site + '/wp-content/plugins/brandco-idx/public/css/brandco-idx-shortcodes.css');

	var widgets = document.querySelectorAll('[data-propertypress-widget]');

	widgets.forEach((widget) => {
		var shortcode = widget.getAttribute('data-propertypress-widget');

		addWidget(shortcode).then((data) => {
			widget.innerHTML = data.html;

			if ( !window.bcoidx ) {
				window.bcoidx = data.window;
				window.bcoidx.fast_ajax = 'https://' + window.propertypress_idx_site + window.bcoidx.fast_ajax;
			}

			window.ppidx_init_shortcodes();
		});
	});

	function propertypress_idx_load_script(url, callback) {
		console.log('IDX Scripts Loaded');
		var head = document.head;
		var script = document.createElement('script');
		script.type = 'text/javascript';
		script.src = url;
		script.onreadystatechange = callback;
		script.onload = callback;
		head.appendChild(script);
	}

	function propertypress_idx_load_stylesheet(url, callback) {
		var head = document.head;
		var script = document.createElement('link');
		script.rel = 'stylesheet';
		script.href = url;
		script.onreadystatechange = callback;
		script.onload = callback;
		head.appendChild(script);
	}
})();
